(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('rxjs/operators'), require('rxjs/index'), require('rxjs/internal/operators'), require('socket.io-client'), require('rxjs'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common/http', 'rxjs/operators', 'rxjs/index', 'rxjs/internal/operators', 'socket.io-client', 'rxjs', '@angular/common'], factory) :
	(factory((global['tms-api'] = {}),global.core,global.http,global.operators,global.index,global.operators$1,global.io,global.rxjs,global.common));
}(this, (function (exports,core,http,operators,index,operators$1,io,rxjs,common) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/** @type {?} */
var API_URL_HTTP = new core.InjectionToken('API_URL_HTTP');
/** @type {?} */
var API_URL_SOCKET = new core.InjectionToken('API_URL_SOCKET');
/** @type {?} */
var APP_VERSION = new core.InjectionToken('APP_VERSION');
/** @type {?} */
var APP_RELEASE = new core.InjectionToken('APP_PROD');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/** @enum {number} */
var Sex = {
    Male: 1,
    // 男
    Female: 2 // 女
    ,
};
Sex[Sex.Male] = 'Male';
Sex[Sex.Female] = 'Female';
/** @type {?} */
var SexMap = {
    '1': '男',
    '2': '女'
};
/** @enum {number} */
var Week = {
    Monday: 1,
    // 周一
    Tuesday: 2,
    // 周二
    Wednesday: 3,
    // 周三
    Thursday: 4,
    // 周四
    Friday: 5,
    // 周五
    Saturday: 6,
    // 周六
    Sunday: 7 // 周日
    ,
};
Week[Week.Monday] = 'Monday';
Week[Week.Tuesday] = 'Tuesday';
Week[Week.Wednesday] = 'Wednesday';
Week[Week.Thursday] = 'Thursday';
Week[Week.Friday] = 'Friday';
Week[Week.Saturday] = 'Saturday';
Week[Week.Sunday] = 'Sunday';
/** @enum {number} */
var ImageType = {
    Single: 1,
    // 单张图片
    Multiple: 2 // 多张图片
    ,
};
ImageType[ImageType.Single] = 'Single';
ImageType[ImageType.Multiple] = 'Multiple';
/** @enum {number} */
var StatusBarType = {
    StatusBar_Transparent: 1,
    // 透明
    StatusBar_BlackText: 2,
    // 白底黑字
    StatusBar_Primary: 3,
};
StatusBarType[StatusBarType.StatusBar_Transparent] = 'StatusBar_Transparent';
StatusBarType[StatusBarType.StatusBar_BlackText] = 'StatusBar_BlackText';
StatusBarType[StatusBarType.StatusBar_Primary] = 'StatusBar_Primary';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var PaginationModel = /** @class */ (function () {
    function PaginationModel() {
    }
    return PaginationModel;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundService = /** @class */ (function () {
    function HoundService() {
        this.keyboardHeight = 300;
        this.hashMap = {};
    }
    // 写数据
    /**
     * @param {?} key
     * @param {?} data
     * @return {?}
     */
    HoundService.prototype.setData = /**
     * @param {?} key
     * @param {?} data
     * @return {?}
     */
    function (key, data) {
        this.hashMap[key] = data;
    };
    // 读数据
    /**
     * @param {?} key
     * @return {?}
     */
    HoundService.prototype.getData = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return this.hashMap[key];
    };
    // 软键盘高度(set)
    /**
     * @param {?} height
     * @return {?}
     */
    HoundService.prototype.setKeyboardHeight = /**
     * @param {?} height
     * @return {?}
     */
    function (height) {
        this.keyboardHeight = height;
    };
    // 软键盘高度(get)
    /**
     * @return {?}
     */
    HoundService.prototype.getKeyboardHeight = /**
     * @return {?}
     */
    function () {
        return this.keyboardHeight;
    };
    // Dom元素(set)
    /**
     * @param {?} element
     * @return {?}
     */
    HoundService.prototype.setDomElement = /**
     * @param {?} element
     * @return {?}
     */
    function (element) {
        this.domElement = element;
    };
    // Dom元素(get)
    /**
     * @return {?}
     */
    HoundService.prototype.getDomElement = /**
     * @return {?}
     */
    function () {
        return this.domElement;
    };
    // 设备版本(set)
    /**
     * @param {?} deviceVersion
     * @return {?}
     */
    HoundService.prototype.setDeviceVersion = /**
     * @param {?} deviceVersion
     * @return {?}
     */
    function (deviceVersion) {
        this.deviceVersion = deviceVersion;
    };
    // 设备版本(get)
    /**
     * @return {?}
     */
    HoundService.prototype.getDeviceVersion = /**
     * @return {?}
     */
    function () {
        return this.deviceVersion;
    };
    HoundService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    HoundService.ctorParameters = function () { return []; };
    return HoundService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundDatetime = /** @class */ (function () {
    function HoundDatetime() {
    }
    // 日期，在原有日期基础上，增加days天数
    /**
     * @param {?} date
     * @param {?} days
     * @return {?}
     */
    HoundDatetime.getDateByAddDays = /**
     * @param {?} date
     * @param {?} days
     * @return {?}
     */
    function (date, days) {
        /** @type {?} */
        var ret = new Date(date);
        ret.setDate(ret.getDate() + days);
        return ret;
    };
    // 日期，在原有日期基础上，增加days天数
    /**
     * @param {?} date
     * @param {?} days
     * @return {?}
     */
    HoundDatetime.getDateStringByAddDays = /**
     * @param {?} date
     * @param {?} days
     * @return {?}
     */
    function (date, days) {
        /** @type {?} */
        var ret = new Date(date);
        ret.setDate(ret.getDate() + days);
        /** @type {?} */
        var month = ret.getMonth() + 1;
        /** @type {?} */
        var day = ret.getDate();
        return this.getTwoDigits(month) + '-' + this.getTwoDigits(day);
    };
    // 时间，在原有时间基础上，增加minutes分钟数
    /**
     * @param {?} date
     * @param {?} minutes
     * @return {?}
     */
    HoundDatetime.getTimeStringByAddMinutes = /**
     * @param {?} date
     * @param {?} minutes
     * @return {?}
     */
    function (date, minutes) {
        /** @type {?} */
        var ret = new Date(date);
        ret.setMinutes(date.getMinutes() + minutes);
        /** @type {?} */
        var hour = ret.getHours();
        /** @type {?} */
        var minute = ret.getMinutes();
        return this.getTwoDigits(hour) + ':' + this.getTwoDigits(minute);
    };
    // 日期月份/天的显示，如果是1位数，则在前面加上'0'
    /**
     * @param {?} arg
     * @return {?}
     */
    HoundDatetime.getTwoDigits = /**
     * @param {?} arg
     * @return {?}
     */
    function (arg) {
        if (arg === undefined || arg === '') {
            return '';
        }
        /** @type {?} */
        var ret = arg + '';
        if (ret.length < 2) {
            ret = '0' + ret;
        }
        return ret;
    };
    // 时间兼容处理
    /**
     * @param {?} time
     * @return {?}
     */
    HoundDatetime.transformDate = /**
     * @param {?} time
     * @return {?}
     */
    function (time) {
        time = time.replace(/-/g, ':').replace(' ', ':');
        time = time.split(':');
        return new Date(time[0], (time[1] - 1), time[2], time[3], time[4], time[5]);
    };
    /**
     * 日期对象转为日期字符串
     * @param date 需要格式化的日期对象
     * @param sFormat 输出格式,默认为yyyy-MM-dd                        年：y，月：M，日：d，时：h，分：m，秒：s
     * @example  dateFormat(new Date())                               "2017-02-28"
     * @example  dateFormat(new Date(),'yyyy-MM-dd')                  "2017-02-28"
     * @example  dateFormat(new Date(),'yyyy-MM-dd HH:mm:ss')         "2017-02-28 13:24:00"   ps:HH:24小时制
     * @example  dateFormat(new Date(),'yyyy-MM-dd hh:mm:ss')         "2017-02-28 01:24:00"   ps:hh:12小时制
     * @example  dateFormat(new Date(),'hh:mm')                       "09:24"
     * @example  dateFormat(new Date(),'yyyy-MM-ddTHH:mm:ss+08:00')   "2017-02-28T13:24:00+08:00"
     * @example  dateFormat(new Date('2017-02-28 13:24:00'),'yyyy-MM-ddTHH:mm:ss+08:00')   "2017-02-28T13:24:00+08:00"
     * @returns {string}
     */
    /**
     * 日期对象转为日期字符串
     * \@example dateFormat(new Date())                               "2017-02-28"
     * \@example dateFormat(new Date(),'yyyy-MM-dd')                  "2017-02-28"
     * \@example dateFormat(new Date(),'yyyy-MM-dd HH:mm:ss')         "2017-02-28 13:24:00"   ps:HH:24小时制
     * \@example dateFormat(new Date(),'yyyy-MM-dd hh:mm:ss')         "2017-02-28 01:24:00"   ps:hh:12小时制
     * \@example dateFormat(new Date(),'hh:mm')                       "09:24"
     * \@example dateFormat(new Date(),'yyyy-MM-ddTHH:mm:ss+08:00')   "2017-02-28T13:24:00+08:00"
     * \@example dateFormat(new Date('2017-02-28 13:24:00'),'yyyy-MM-ddTHH:mm:ss+08:00')   "2017-02-28T13:24:00+08:00"
     * @param {?} date 需要格式化的日期对象
     * @param {?=} sFormat 输出格式,默认为yyyy-MM-dd                        年：y，月：M，日：d，时：h，分：m，秒：s
     * @return {?}
     */
    HoundDatetime.getFormatDate = /**
     * 日期对象转为日期字符串
     * \@example dateFormat(new Date())                               "2017-02-28"
     * \@example dateFormat(new Date(),'yyyy-MM-dd')                  "2017-02-28"
     * \@example dateFormat(new Date(),'yyyy-MM-dd HH:mm:ss')         "2017-02-28 13:24:00"   ps:HH:24小时制
     * \@example dateFormat(new Date(),'yyyy-MM-dd hh:mm:ss')         "2017-02-28 01:24:00"   ps:hh:12小时制
     * \@example dateFormat(new Date(),'hh:mm')                       "09:24"
     * \@example dateFormat(new Date(),'yyyy-MM-ddTHH:mm:ss+08:00')   "2017-02-28T13:24:00+08:00"
     * \@example dateFormat(new Date('2017-02-28 13:24:00'),'yyyy-MM-ddTHH:mm:ss+08:00')   "2017-02-28T13:24:00+08:00"
     * @param {?} date 需要格式化的日期对象
     * @param {?=} sFormat 输出格式,默认为yyyy-MM-dd                        年：y，月：M，日：d，时：h，分：m，秒：s
     * @return {?}
     */
    function (date, sFormat) {
        if (sFormat === void 0) { sFormat = 'yyyy-MM-dd'; }
        /** @type {?} */
        var time = {
            Year: 0,
            TYear: '0',
            Month: 0,
            TMonth: '0',
            Day: 0,
            TDay: '0',
            Hour: 0,
            THour: '0',
            hour: 0,
            Thour: '0',
            Minute: 0,
            TMinute: '0',
            Second: 0,
            TSecond: '0',
            Millisecond: 0
        };
        time.Year = date.getFullYear();
        time.TYear = String(time.Year).substr(2);
        time.Month = date.getMonth() + 1;
        time.TMonth = time.Month < 10 ? '0' + time.Month : String(time.Month);
        time.Day = date.getDate();
        time.TDay = time.Day < 10 ? '0' + time.Day : String(time.Day);
        time.Hour = date.getHours();
        time.THour = time.Hour < 10 ? '0' + time.Hour : String(time.Hour);
        time.hour = time.Hour < 13 ? time.Hour : time.Hour - 12;
        time.Thour = time.hour < 10 ? '0' + time.hour : String(time.hour);
        time.Minute = date.getMinutes();
        time.TMinute = time.Minute < 10 ? '0' + time.Minute : String(time.Minute);
        time.Second = date.getSeconds();
        time.TSecond = time.Second < 10 ? '0' + time.Second : String(time.Second);
        time.Millisecond = date.getMilliseconds();
        return sFormat.replace(/yyyy/ig, String(time.Year))
            .replace(/yyy/ig, String(time.Year))
            .replace(/yy/ig, time.TYear)
            .replace(/y/ig, time.TYear)
            .replace(/MM/g, time.TMonth)
            .replace(/M/g, String(time.Month))
            .replace(/dd/ig, time.TDay)
            .replace(/d/ig, String(time.Day))
            .replace(/HH/g, time.THour)
            .replace(/H/g, String(time.Hour))
            .replace(/hh/g, time.Thour)
            .replace(/h/g, String(time.hour))
            .replace(/mm/g, time.TMinute)
            .replace(/m/g, String(time.Minute))
            .replace(/ss/ig, time.TSecond)
            .replace(/s/ig, String(time.Second))
            .replace(/fff/ig, String(time.Millisecond));
    };
    return HoundDatetime;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundLog = /** @class */ (function () {
    function HoundLog() {
    }
    /**
     * @param {?=} tag
     * @param {?=} message
     * @return {?}
     */
    HoundLog.log = /**
     * @param {?=} tag
     * @param {?=} message
     * @return {?}
     */
    function (tag, message) {
        if (this.debug) {
            if (message == null) {
                console.log(tag);
            }
            else {
                console.log(tag, message);
            }
        }
    };
    /**
     * @param {?=} tag
     * @param {?=} message
     * @return {?}
     */
    HoundLog.warn = /**
     * @param {?=} tag
     * @param {?=} message
     * @return {?}
     */
    function (tag, message) {
        if (this.debug) {
            if (message == null) {
                console.warn(tag);
            }
            else {
                console.warn(tag, message);
            }
        }
    };
    /**
     * @param {?=} tag
     * @param {?=} message
     * @return {?}
     */
    HoundLog.error = /**
     * @param {?=} tag
     * @param {?=} message
     * @return {?}
     */
    function (tag, message) {
        if (this.debug) {
            if (message == null) {
                console.error(tag);
            }
            else {
                console.error(tag, message);
            }
        }
    };
    HoundLog.debug = true;
    return HoundLog;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundMath = /** @class */ (function () {
    function HoundMath() {
    }
    // 除法
    /**
     * @param {?} arg1
     * @param {?} arg2
     * @return {?}
     */
    HoundMath.accDiv = /**
     * @param {?} arg1
     * @param {?} arg2
     * @return {?}
     */
    function (arg1, arg2) {
        /** @type {?} */
        var t1 = 0;
        /** @type {?} */
        var t2 = 0;
        /** @type {?} */
        var t3 = 0;
        /** @type {?} */
        var r1;
        /** @type {?} */
        var r2;
        try {
            t1 = arg1.toString().split('.')[1].length;
        }
        catch (e) {
        }
        try {
            t2 = arg2.toString().split('.')[1].length;
        }
        catch (e) {
        }
        r1 = Number(arg1.toString().replace('.', ''));
        r2 = Number(arg2.toString().replace('.', ''));
        if (r2 === 0) {
            return 0;
        }
        /** @type {?} */
        var result = String(r1 / r2);
        try {
            t3 = result.toString().split('.')[1].length;
        }
        catch (e) {
        }
        /** @type {?} */
        var index$$1 = t2 - t1 - t3;
        if (index$$1 < 0) {
            result = result.replace('.', '');
            while (result.length <= Math.abs(index$$1)) {
                result = '0' + result;
            }
            /** @type {?} */
            var start = result.substring(0, result.length + index$$1);
            /** @type {?} */
            var end = result.substring(result.length + index$$1, result.length);
            result = start + '.' + end;
            return Number(result);
        }
        else if (index$$1 > 0) {
            result = result.replace('.', '');
            while (result.length <= Math.abs(index$$1)) {
                result += '0';
            }
            return Number(result);
        }
        else {
            return Number(result.replace('.', ''));
        }
    };
    // 乘法
    /**
     * @param {?} arg1
     * @param {?} arg2
     * @return {?}
     */
    HoundMath.accMul = /**
     * @param {?} arg1
     * @param {?} arg2
     * @return {?}
     */
    function (arg1, arg2) {
        /** @type {?} */
        var m = 0;
        /** @type {?} */
        var s1 = arg1.toString();
        /** @type {?} */
        var s2 = arg2.toString();
        try {
            m += s1.split('.')[1].length;
        }
        catch (e) {
        }
        try {
            m += s2.split('.')[1].length;
        }
        catch (e) {
        }
        return Number(s1.replace('.', '')) * Number(s2.replace('.', '')) / Math.pow(10, m);
    };
    // 加法
    /**
     * @param {?} arg1
     * @param {?} arg2
     * @return {?}
     */
    HoundMath.accAdd = /**
     * @param {?} arg1
     * @param {?} arg2
     * @return {?}
     */
    function (arg1, arg2) {
        /** @type {?} */
        var r1;
        /** @type {?} */
        var r2;
        /** @type {?} */
        var m;
        /** @type {?} */
        var c;
        try {
            r1 = arg1.toString().split('.')[1].length;
        }
        catch (e) {
            r1 = 0;
        }
        try {
            r2 = arg2.toString().split('.')[1].length;
        }
        catch (e) {
            r2 = 0;
        }
        c = Math.abs(r1 - r2);
        m = Math.pow(10, Math.max(r1, r2));
        if (c > 0) {
            /** @type {?} */
            var cm = Math.pow(10, c);
            if (r1 > r2) {
                arg1 = Number(arg1.toString().replace('.', ''));
                arg2 = Number(arg2.toString().replace('.', '')) * cm;
            }
            else {
                arg1 = Number(arg1.toString().replace('.', '')) * cm;
                arg2 = Number(arg2.toString().replace('.', ''));
            }
        }
        else {
            arg1 = Number(arg1.toString().replace('.', ''));
            arg2 = Number(arg2.toString().replace('.', ''));
        }
        return (arg1 + arg2) / m;
    };
    return HoundMath;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundObject = /** @class */ (function () {
    function HoundObject() {
    }
    // 克隆Object
    /**
     * @param {?} Obj
     * @return {?}
     */
    HoundObject.clone = /**
     * @param {?} Obj
     * @return {?}
     */
    function (Obj) {
        /** @type {?} */
        var buf;
        if (Obj instanceof Array) {
            /** @type {?} */
            var bufArray = [];
            /** @type {?} */
            var i = Obj.length;
            while (i--) {
                bufArray[i] = this.clone(Obj[i]);
            }
            return bufArray;
        }
        else if (Obj instanceof Object) {
            // 创建一个空对象
            buf = {};
            for (var k in Obj) {
                if (Obj.hasOwnProperty(k)) {
                    buf[k] = this.clone(Obj[k]);
                }
            }
            return buf;
        }
        else {
            return Obj;
        }
    };
    return HoundObject;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundHttpOptionsModel = /** @class */ (function () {
    function HoundHttpOptionsModel() {
        // 是否携带cookie
        this.withCredentials = true;
    }
    return HoundHttpOptionsModel;
}());
var HoundHttpResponseModel = /** @class */ (function () {
    function HoundHttpResponseModel() {
    }
    return HoundHttpResponseModel;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundSocketRequestModel = /** @class */ (function () {
    function HoundSocketRequestModel() {
    }
    return HoundSocketRequestModel;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/** @enum {number} */
var HTTP_STATUS_SPECIFIC = {
    // 未登录
    NOT_LOGIN: 10114,
};
HTTP_STATUS_SPECIFIC[HTTP_STATUS_SPECIFIC.NOT_LOGIN] = 'NOT_LOGIN';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/** @type {?} */
var HTTP_STATUS = {
    '0': '无法连接服务器。',
    '400': '错误的请求。由于语法错误，该请求无法完成。',
    '401': '未经授权。服务器拒绝响应。',
    '403': '已禁止。服务器拒绝响应。',
    '404': '未找到。无法找到请求的位置。',
    '405': '方法不被允许。使用该位置不支持的请求方法进行了请求。',
    '406': '不可接受。服务器只生成客户端不接受的响应。',
    '407': '需要代理身份验证。客户端必须先使用代理对自身进行身份验证。',
    '408': '请求超时。等待请求的服务器超时。',
    '409': '冲突。由于请求中的冲突，无法完成该请求。',
    '410': '过期。请求页不再可用。',
    '411': '长度必需。未定义“内容长度”。',
    '412': '前提条件不满足。请求中给定的前提条件由服务器评估为 false。',
    '413': '请求实体太大。服务器不会接受请求，因为请求实体太大。',
    '414': '请求 URI 太长。服务器不会接受该请求，因为 URL 太长。',
    '415': '不支持的媒体类型。服务器不会接受该请求，因为媒体类型不受支持。',
    '416': 'HTTP 状态代码 {0}',
    '500': '内部服务器错误。',
    '501': '未实现。服务器不识别该请求方法，或者服务器没有能力完成请求。',
    '503': '服务不可用。服务器当前不可用(过载或故障)。'
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/** @type {?} */
var HTTP_STATUS_SPECIFIC_CODE_OK = 200;
/** @type {?} */
var HTTP_STATUS_SPECIFIC_CODE_START = 10000;
/** @type {?} */
var HTTP_STATUS_SPECIFIC$1 = {
    // 相关错误
    '10001': '参数错误',
    '10107': '账号或密码错误'
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundHttpService = /** @class */ (function () {
    function HoundHttpService() {
    }
    /**
     * @param {?} response
     * @return {?}
     */
    HoundHttpService.prototype.checkResponseJson = /**
     * @param {?} response
     * @return {?}
     */
    function (response) {
        if ((/** @type {?} */ (response)).statusCodeValue === HTTP_STATUS_SPECIFIC_CODE_OK) {
            return true;
        }
        else {
            this.throwResponseError(response);
        }
    };
    /**
     * @param {?} response
     * @return {?}
     */
    HoundHttpService.prototype.throwResponseError = /**
     * @param {?} response
     * @return {?}
     */
    function (response) {
        throw { status: (/** @type {?} */ (response)).statusCodeValue };
    };
    /**
     * @param {?} response
     * @return {?}
     */
    HoundHttpService.prototype.getResponseModel = /**
     * @param {?} response
     * @return {?}
     */
    function (response) {
        if (this.checkResponseJson(response)) {
            /** @type {?} */
            var responseModel = new HoundHttpResponseModel();
            if ((/** @type {?} */ (response)).statusCodeValue === HTTP_STATUS_SPECIFIC_CODE_OK) {
                responseModel.success = true;
                responseModel.message = (/** @type {?} */ (response)).statusCode;
            }
            else {
                responseModel.success = false;
                responseModel.message = (/** @type {?} */ (response)).statusCode;
            }
            return responseModel;
        }
    };
    /**
     * @param {?} response
     * @return {?}
     */
    HoundHttpService.prototype.handleHttpError = /**
     * @param {?} response
     * @return {?}
     */
    function (response) {
        if (response.status > HTTP_STATUS_SPECIFIC_CODE_START) {
            return index.throwError({
                statusCode: HTTP_STATUS_SPECIFIC$1[response.status],
                statusCodeValue: response.status
            });
        }
        else {
            return index.throwError({
                statusCode: HTTP_STATUS[response.status],
                statusCodeValue: response.status
            });
        }
    };
    /**
     * @param {?} httpClient
     * @param {?} url
     * @param {?=} options
     * @return {?}
     */
    HoundHttpService.prototype.doGetRequest = /**
     * @param {?} httpClient
     * @param {?} url
     * @param {?=} options
     * @return {?}
     */
    function (httpClient, url, options) {
        var _this = this;
        return httpClient.get(url, options).pipe(operators$1.tap(function (response) {
            HoundLog.log('doGetRequest-data', response);
        }), operators$1.map(function (response) {
            return _this.getResponseModel(response);
        }), operators$1.catchError(function (response) {
            return _this.handleHttpError(response);
        }));
    };
    /**
     * @param {?} httpClient
     * @param {?} url
     * @param {?} obj
     * @param {?=} options
     * @return {?}
     */
    HoundHttpService.prototype.doPostRequest = /**
     * @param {?} httpClient
     * @param {?} url
     * @param {?} obj
     * @param {?=} options
     * @return {?}
     */
    function (httpClient, url, obj, options) {
        var _this = this;
        return httpClient.post(url, obj, options).pipe(operators$1.tap(function (response) {
            HoundLog.log('doPostRequest-data', response);
        }), operators$1.map(function (response) {
            return _this.getResponseModel(response);
        }), operators$1.catchError(function (response) {
            return _this.handleHttpError(response);
        }));
    };
    /**
     * @param {?} httpClient
     * @param {?} url
     * @param {?} obj
     * @param {?=} options
     * @return {?}
     */
    HoundHttpService.prototype.doPutRequest = /**
     * @param {?} httpClient
     * @param {?} url
     * @param {?} obj
     * @param {?=} options
     * @return {?}
     */
    function (httpClient, url, obj, options) {
        var _this = this;
        return httpClient.put(url, obj, options).pipe(operators$1.tap(function (response) {
            HoundLog.log('doPutRequest-data', response);
        }), operators$1.map(function (response) {
            return _this.getResponseModel(response);
        }), operators$1.catchError(function (response) {
            return _this.handleHttpError(response);
        }));
    };
    /**
     * @param {?} httpClient
     * @param {?} url
     * @param {?=} options
     * @return {?}
     */
    HoundHttpService.prototype.doDelRequest = /**
     * @param {?} httpClient
     * @param {?} url
     * @param {?=} options
     * @return {?}
     */
    function (httpClient, url, options) {
        var _this = this;
        return httpClient.delete(url, options).pipe(operators$1.tap(function (response) {
            HoundLog.log('doDelRequest-data', response);
        }), operators$1.map(function (response) {
            return _this.getResponseModel(response);
        }), operators$1.catchError(function (response) {
            return _this.handleHttpError(response);
        }));
    };
    return HoundHttpService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundSocketService = /** @class */ (function () {
    function HoundSocketService(apiUrlSocket) {
        this.apiUrlSocket = apiUrlSocket;
        this.init();
    }
    /**
     * @return {?}
     */
    HoundSocketService.prototype.init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.socket = io.connect(this.apiUrlSocket);
        this.socket.on('connect', function () {
            HoundLog.log('HoundSocketService Server Connected:', _this.socket.id);
        });
    };
    /**
     * @param {?} requestModel
     * @return {?}
     */
    HoundSocketService.prototype.doSocketRequest = /**
     * @param {?} requestModel
     * @return {?}
     */
    function (requestModel) {
        var _this = this;
        /** @type {?} */
        var observable = rxjs.Observable.create(function (observer) {
            _this.socket.on(requestModel.callback, function (data) {
                observer.next(data);
            });
            _this.socket.emit('JSON-RPC', {
                method: requestModel.method,
                datas: requestModel.body,
                callBackEmit: requestModel.callback
            }, function (data) {
                HoundLog.log('HoundSocketService doSocketRequest:', data);
            });
        });
        return observable;
    };
    HoundSocketService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    HoundSocketService.ctorParameters = function () { return [
        { type: String, decorators: [{ type: core.Inject, args: [API_URL_SOCKET,] }] }
    ]; };
    return HoundSocketService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var DemoService = /** @class */ (function () {
    function DemoService(httpService, httpClient, socketService, apiUrlHttp, apiUrlSocket) {
        this.httpService = httpService;
        this.httpClient = httpClient;
        this.socketService = socketService;
        this.apiUrlHttp = apiUrlHttp;
        this.apiUrlSocket = apiUrlSocket;
    }
    // 登录http
    /**
     * @param {?} phone
     * @param {?} password
     * @return {?}
     */
    DemoService.prototype.doLogin = /**
     * @param {?} phone
     * @param {?} password
     * @return {?}
     */
    function (phone, password) {
        var _this = this;
        /** @type {?} */
        var url = this.apiUrlHttp + "/login?phone=" + phone + "&password=" + password;
        HoundLog.log('doLogin-url', url);
        /** @type {?} */
        var jsonObj = {};
        return this.httpClient.post(url, jsonObj, new HoundHttpOptionsModel()).pipe(operators.tap(function (response) {
            HoundLog.log('doLogin-data', response);
        }), operators.map(function (response) {
            if (_this.httpService.checkResponseJson(response)) {
                return response['body'];
            }
        }), operators.catchError(function (response) {
            return _this.httpService.handleHttpError(response);
        }));
    };
    // 测试socket
    /**
     * @param {?} speakArray
     * @return {?}
     */
    DemoService.prototype.doSpeck = /**
     * @param {?} speakArray
     * @return {?}
     */
    function (speakArray) {
        var _this = this;
        /** @type {?} */
        var socketRequest = new HoundSocketRequestModel();
        socketRequest.method = 'TestService.speak2';
        socketRequest.body = speakArray;
        socketRequest.callback = '123';
        /** @type {?} */
        var url = this.apiUrlSocket + "/" + socketRequest.method;
        HoundLog.log('doSpeck-method', url);
        return this.socketService.doSocketRequest(socketRequest).pipe(operators.tap(function (response) {
            HoundLog.log('doSpeck-data', response);
        }), operators.map(function (response) {
            if (_this.httpService.checkResponseJson(response)) {
                return response['body'];
            }
        }), operators.catchError(function (response) {
            return _this.httpService.handleHttpError(response);
        }));
    };
    DemoService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    DemoService.ctorParameters = function () { return [
        { type: HoundHttpService },
        { type: http.HttpClient },
        { type: HoundSocketService },
        { type: String, decorators: [{ type: core.Inject, args: [API_URL_HTTP,] }] },
        { type: String, decorators: [{ type: core.Inject, args: [API_URL_SOCKET,] }] }
    ]; };
    return DemoService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundModule = /** @class */ (function () {
    function HoundModule() {
    }
    HoundModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [],
                    imports: [common.CommonModule],
                    exports: [],
                    providers: [
                        { provide: HoundService, useClass: HoundService }
                    ]
                },] },
    ];
    return HoundModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var DemoModule = /** @class */ (function () {
    function DemoModule() {
    }
    DemoModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [],
                    imports: [common.CommonModule, http.HttpClientModule],
                    providers: [
                        { provide: DemoService, useClass: DemoService },
                    ],
                    exports: []
                },] },
    ];
    return DemoModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundHttpModule = /** @class */ (function () {
    function HoundHttpModule() {
    }
    HoundHttpModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [],
                    imports: [common.CommonModule, http.HttpClientModule],
                    providers: [
                        { provide: HoundHttpService, useClass: HoundHttpService }
                    ],
                    exports: []
                },] },
    ];
    return HoundHttpModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HoundSocketModule = /** @class */ (function () {
    function HoundSocketModule() {
    }
    HoundSocketModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [],
                    imports: [common.CommonModule, http.HttpClientModule],
                    providers: [
                        { provide: HoundSocketService, useClass: HoundSocketService }
                    ],
                    exports: []
                },] },
    ];
    return HoundSocketModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var TmsApiModule = /** @class */ (function () {
    function TmsApiModule() {
    }
    TmsApiModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [],
                    imports: [
                        common.CommonModule,
                        HoundModule,
                        HoundHttpModule,
                        HoundSocketModule,
                        DemoModule
                    ],
                    exports: [],
                    providers: []
                },] },
    ];
    return TmsApiModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

exports.API_URL_HTTP = API_URL_HTTP;
exports.API_URL_SOCKET = API_URL_SOCKET;
exports.APP_VERSION = APP_VERSION;
exports.APP_RELEASE = APP_RELEASE;
exports.Sex = Sex;
exports.SexMap = SexMap;
exports.Week = Week;
exports.ImageType = ImageType;
exports.StatusBarType = StatusBarType;
exports.PaginationModel = PaginationModel;
exports.HoundService = HoundService;
exports.HoundDatetime = HoundDatetime;
exports.HoundLog = HoundLog;
exports.HoundMath = HoundMath;
exports.HoundObject = HoundObject;
exports.HoundHttpOptionsModel = HoundHttpOptionsModel;
exports.HoundHttpResponseModel = HoundHttpResponseModel;
exports.HoundSocketRequestModel = HoundSocketRequestModel;
exports.HTTP_STATUS_SPECIFIC = HTTP_STATUS_SPECIFIC;
exports.DemoService = DemoService;
exports.TmsApiModule = TmsApiModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
